///////////////////////////////////////////////////////////
//                      MobSurgeon                       //
//           mob-            //
//           Copyright (C) 2005-2007 Gipat Group         //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------


#pragma hdrstop

#include "MobLeverObj.h"
#include "MobFormat.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

///////////////////////////////////
//TLeverObjBlock
///////////////////////////////////

DWORD TLeverObjBlock::GetBlockSize()
//       .
{
  //...
  DWORD Result = 65;
  int i;
  //65 -    .

  //       
  //  ...
  Result = Result + TObjectObjBlock::GetBlockSize();

  return Result;
};

bool TLeverObjBlock::ReadBlock(byte *Buff, DWORD BuffSize, bool UseLog, TMob *PMobObj)
//     .
{
  // ...
  DWORD TempDW1, MinBlockSgn, MinBlockSize, TempDW2, i;
  bool Result = true;
  __int64 Cursor = 8;

  //    .
  do
  {
    //  ...
    memcpy(&MinBlockSgn,&Buff[Cursor],4);
    Cursor = Cursor+4;
    //     ...
    if (MinBlockSgn == Lvr_Sgn_SwitchParams)
    {
      //   .
      //DWORD X 3

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&AsOpen,&Buff[Cursor],4);
      Cursor = Cursor+4;
      memcpy(&Key,&Buff[Cursor],4);
      Cursor = Cursor+4;
      memcpy(&Sleigth,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }


    else if (MinBlockSgn == Lvr_Sgn_UnknByte2)
    {
      // byte2.
      //byte

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&UncnByte2,&Buff[Cursor],1);
      Cursor = Cursor+1;
    }

    else if (MinBlockSgn == Lvr_Sgn_UnknByte3)
    {
      // byte3.
      //byte

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&UncnByte3,&Buff[Cursor],1);
      Cursor = Cursor+1;
    }

    else if (MinBlockSgn == Lvr_Sgn_UnknByte4)
    {
      // byte4.
      //byte

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&UncnByte4,&Buff[Cursor],1);
      Cursor = Cursor+1;
    }

    else if (MinBlockSgn == Lvr_Sgn_UnknByte5)
    {
      // byte5.
      //byte

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&UncnByte5,&Buff[Cursor],1);
      Cursor = Cursor+1;
    }

    else if (MinBlockSgn == Lvr_Sgn_UnknByte6)
    {
      // byte6.
      //byte

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&UncnByte6,&Buff[Cursor],1);
      Cursor = Cursor+1;
    }

    else if (MinBlockSgn == Obj_Sgn_BodyTextures)  //       ...
    {
      //  -       ...
      MinBlockSize = GetNMobBlocksSize(Buff,Cursor-4,17);  //    
      TObjectObjBlock::ReadBlock(&Buff[Cursor-12],MinBlockSize+8,UseLog,PMobObj);
      Cursor = Cursor+MinBlockSize-4;  //   . ...
    };

  }
  while (Cursor != BuffSize);

  StopLoadUnitBlock:        //     .
  ;
  return Result;
};

byte* TLeverObjBlock::GenBlock(DWORD& BlockSize)
// ...
{
  //
  byte* Result = NULL;
  int i = 0; //
  DWORD ChetireBaita, BlockSignature;
  DWORD Cursor = 0;

  //, .      ...
  BlockSize = GetBlockSize();
  Result = new byte[BlockSize];

  // ...
  memcpy(&Result[Cursor],&OB_Sgn_Lever,4);
  Cursor = Cursor+4;

  // .
  memcpy(&Result[Cursor],&BlockSize,4);
  Cursor = Cursor+4;
  
  //   .
  //DWORD X 3
  // 
  memcpy(&Result[Cursor],&Lvr_Sgn_SwitchParams,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 20;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&AsOpen,4);
  Cursor = Cursor+4;
  memcpy(&Result[Cursor],&Key,4);
  Cursor = Cursor+4;
  memcpy(&Result[Cursor],&Sleigth,4);
  Cursor = Cursor+4;

  // byte2.
  //byte
  // 
  memcpy(&Result[Cursor],&Lvr_Sgn_UnknByte2,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 9;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&UncnByte2,1);
  Cursor = Cursor+1;

  // byte3.
  //byte
  // 
  memcpy(&Result[Cursor],&Lvr_Sgn_UnknByte3,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 9;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&UncnByte3,1);
  Cursor = Cursor+1;

  // byte4.
  //byte
  // 
  memcpy(&Result[Cursor],&Lvr_Sgn_UnknByte4,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 9;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&UncnByte4,1);
  Cursor = Cursor+1;

  // byte5.
  //byte
  // 
  memcpy(&Result[Cursor],&Lvr_Sgn_UnknByte5,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 9;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&UncnByte5,1);
  Cursor = Cursor+1;

  // byte6.
  //byte
  // 
  memcpy(&Result[Cursor],&Lvr_Sgn_UnknByte6,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 9;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&UncnByte6,1);
  Cursor = Cursor+1;

  //    ...
  TObjectObjBlock::GenBasePart(&Result[Cursor]);
  Cursor = Cursor+TObjectObjBlock::GetBlockSize()-8;

  //  ...
  return Result;
};
