///////////////////////////////////////////////////////////
//                      MobSurgeon                       //
//           mob-            //
//           Copyright (C) 2005-2007 Gipat Group         //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------

#ifndef initerH
#define initerH

#include "VersionInfo.hpp"
#include "MobFormat.h"
#include <IniFiles.hpp>
#include "VerInfoTxtFormat.hpp"
#include "MobSurgeon_ver.h"

//---------------------------------------------------------------------------

//.
const String IniFileName = "MobSurgeon.ini";
const Integer IniFileVer = 6;

// -   .
const String MobSurgeon_AppName = "MobSurgeon";
const String MobSurgeon_AppDescription = "       ";
const String MobSurgeon_Copyright = "Copyright  2005-2009 Gipat Group";
const String MobSurgeon_CraftedBy = "Sagrer, ";
const String MobSurgeon_DevelsContacts = "www.GipatGroup.org";

//- .
//[Main]
const bool StandUseTMobThreads = false;  //      TMob;
const Integer StandSaveAttempts = 10;    //     .
const bool StandMakeAutoBackups = true;  //  ...
const String StandSearchStr = "";        //   ...
const String StandRepStr = "";           //   ...
const bool StandMakeReplace = false;     //    \  .
//[MassChangeOpts]
const bool Stand_MC_KR_Param_Name1CB_ini = false;
const bool Stand_MC_KR_Param_Name2CB_ini = false;
const bool Stand_MC_KR_Param_ScriptVariableNameCB_ini = false;
const bool Stand_MC_KR_Param_Model3dCB_ini = false;
const bool Stand_MC_KR_Param_FirstTextureCB_ini = false;
const bool Stand_MC_KR_Param_SecondTextureCB_ini = false;
const bool Stand_MC_KR_Param_PlayerNumberCB_ini = false;
const bool Stand_MC_KR_Coords_PramouglCB_ini = false;
const bool Stand_MC_KR_Coords_KrugCB_ini = false;
const bool Stand_MC_KR_Type_UnitCB_ini = false;
const bool Stand_MC_KR_Type_ObjectCB_ini = false;
const bool Stand_MC_KR_Type_LeverCB_ini = false;
const bool Stand_MC_KR_Type_TrapCB_ini = false;
const bool Stand_MC_KR_Type_FlameCB_ini = false;
const bool Stand_MC_KR_Type_Particle1CB_ini = false;
const bool Stand_MC_KR_Type_Particle2CB_ini = false;
const bool Stand_MC_KR_Type_Particle3CB_ini = false;
const bool Stand_MC_AS_Obj_DelRB_ini = false;
const bool Stand_MC_AS_Obj_CopyRB_ini = false;
const bool Stand_MC_AS_Obj_MoveRB_ini = false;
const bool Stand_MC_AS_Obj_ReplaceCB_ini = true;
const bool Stand_MC_AS_Params_Name1CB_ini = false;
const bool Stand_MC_AS_Params_Name2CB_ini = false;
const bool Stand_MC_AS_Params_ScriptVariableNameCB_ini = false;
const bool Stand_MC_AS_Params_Model3dCB_ini = false;
const bool Stand_MC_AS_Params_FirstTextureCB_ini = false;
const bool Stand_MC_AS_Params_SecondTextureCB_ini = false;
const bool Stand_MC_AS_Params_OffsetCB_ini = false;
const bool Stand_MC_AS_Params_PlayerNumberCB_ini = false;
const bool Stand_MC_AS_Obj_OnlyParamsRB_ini = true;
const String Stand_MC_KR_Param_Name1Ed_ini = "";
const String Stand_MC_KR_Param_Name2Ed_ini = "";
const String Stand_MC_KR_Param_ScriptVariableNameEd_ini = "";
const String Stand_MC_KR_Param_Model3dEd_ini = "";
const String Stand_MC_KR_Param_FirstTextureEd_ini = "";
const String Stand_MC_KR_Param_SecondTextureEd_ini = "";
const String Stand_MC_KR_Param_PlayerNumberEd_ini = "";
const String Stand_MC_KR_Coords_Pramougl_X1Ed_ini = "";
const String Stand_MC_KR_Coords_Pramougl_Y1Ed_ini = "";
const String Stand_MC_KR_Coords_Pramougl_X2Ed_ini = "";
const String Stand_MC_KR_Coords_Pramougl_Y2Ed_ini = "";
const String Stand_MC_KR_Coords_Krug_XEd_ini = "";
const String Stand_MC_KR_Coords_Krug_YEd_ini = "";
const String Stand_MC_KR_Coords_Krug_RadEd_ini = "";
const String Stand_MC_AS_Obj_TargetMobEd_ini = "";
const String Stand_MC_AS_Params_Name1Ed_ini = "";
const String Stand_MC_AS_Params_Name2Ed_ini = "";
const String Stand_MC_AS_Params_ScriptVariableNameEd_ini = "";
const String Stand_MC_AS_Params_Model3dEd_ini = "";
const String Stand_MC_AS_Params_FirstTextureEd_ini = "";
const String Stand_MC_AS_Params_SecondTextureEd_ini = "";
const String Stand_MC_AS_Params_OffsetXEd_ini = "";
const String Stand_MC_AS_Params_OffsetYEd_ini = "";
const String Stand_MC_AS_Params_PlayerNumberEd_ini = "";

//-,     ini
//[Main]
extern bool UseTMobThreads;     //      TMob;
extern Integer SaveAttempts;    //     .
extern String WorkPath;         // .
extern bool MakeAutoBackups;    //  ...
extern String SearchStr;        //  ...
extern String RepStr;           //  ...
extern bool MakeReplace;     //    \.
//[MassChangeOpts]
extern bool MC_KR_Param_Name1CB_ini;
extern bool MC_KR_Param_Name2CB_ini;
extern bool MC_KR_Param_ScriptVariableNameCB_ini;
extern bool MC_KR_Param_Model3dCB_ini;
extern bool MC_KR_Param_FirstTextureCB_ini;
extern bool MC_KR_Param_SecondTextureCB_ini;
extern bool MC_KR_Param_PlayerNumberCB_ini;
extern bool MC_KR_Coords_PramouglCB_ini;
extern bool MC_KR_Coords_KrugCB_ini;
extern bool MC_KR_Type_UnitCB_ini;
extern bool MC_KR_Type_ObjectCB_ini;
extern bool MC_KR_Type_LeverCB_ini;
extern bool MC_KR_Type_TrapCB_ini;
extern bool MC_KR_Type_FlameCB_ini;
extern bool MC_KR_Type_Particle1CB_ini;
extern bool MC_KR_Type_Particle2CB_ini;
extern bool MC_KR_Type_Particle3CB_ini;
extern bool MC_AS_Obj_DelRB_ini;
extern bool MC_AS_Obj_CopyRB_ini;
extern bool MC_AS_Obj_MoveRB_ini;
extern bool MC_AS_Obj_ReplaceCB_ini;
extern bool MC_AS_Params_Name1CB_ini;
extern bool MC_AS_Params_Name2CB_ini;
extern bool MC_AS_Params_ScriptVariableNameCB_ini;
extern bool MC_AS_Params_Model3dCB_ini;
extern bool MC_AS_Params_FirstTextureCB_ini;
extern bool MC_AS_Params_SecondTextureCB_ini;
extern bool MC_AS_Params_OffsetCB_ini;
extern bool MC_AS_Params_PlayerNumberCB_ini;
extern bool MC_AS_Obj_OnlyParamsRB_ini;
extern String MC_KR_Param_Name1Ed_ini;
extern String MC_KR_Param_Name2Ed_ini;
extern String MC_KR_Param_ScriptVariableNameEd_ini;
extern String MC_KR_Param_Model3dEd_ini;
extern String MC_KR_Param_FirstTextureEd_ini;
extern String MC_KR_Param_SecondTextureEd_ini;
extern String MC_KR_Param_PlayerNumberEd_ini;
extern String MC_KR_Coords_Pramougl_X1Ed_ini;
extern String MC_KR_Coords_Pramougl_Y1Ed_ini;
extern String MC_KR_Coords_Pramougl_X2Ed_ini;
extern String MC_KR_Coords_Pramougl_Y2Ed_ini;
extern String MC_KR_Coords_Krug_XEd_ini;
extern String MC_KR_Coords_Krug_YEd_ini;
extern String MC_KR_Coords_Krug_RadEd_ini;
extern String MC_AS_Obj_TargetMobEd_ini;
extern String MC_AS_Params_Name1Ed_ini;
extern String MC_AS_Params_Name2Ed_ini;
extern String MC_AS_Params_ScriptVariableNameEd_ini;
extern String MC_AS_Params_Model3dEd_ini;
extern String MC_AS_Params_FirstTextureEd_ini;
extern String MC_AS_Params_SecondTextureEd_ini;
extern String MC_AS_Params_OffsetXEd_ini;
extern String MC_AS_Params_OffsetYEd_ini;
extern String MC_AS_Params_PlayerNumberEd_ini;

//   ...
extern TVerInfoTxtFormat *VitInfo;
extern String ProgPath, MobFileName;
extern TMob *MobInMem1, *TargetMob;
extern bool MobLoaded, SearchDialCanceled, MakeSLBlockInterf, MobModified;
extern TIniFile *MainIni;

// -.

// .
void AppInit();   //  RUN
void AppDeInit(); //  RUN
bool OpenMobComm(const AnsiString FileName); //     .
bool SaveMobComm(); //     .
bool SaveAsMobComm();  //         .
bool CloseMobComm();  //     .
void SaveInterfInfo();  //        ...
void SetStandProgSetts();  //      .
void LoadProgSetts();  //     .
void SaveProgSetts();  //     .
AnsiString ExtractFileNameNoExt(const AnsiString FileName);  //    .
void MakeUserBackup(const AnsiString FileName);  //  .
void MakeAutoBackup(const AnsiString FileName);  //  .
bool CheckMCFormValues();  //    .
void MakeMassChanges();  //  .
bool MakeMassChangeAction(const DWORD ObjType, DWORD ObjNumber);  // -   .
bool MakeMassChangeFilter(const DWORD ObjType, DWORD ObjNumber);  // -   .

// .
AnsiString Win2UnixLBText(AnsiString& InputStr);  //          ...
AnsiString StrArray2StrCommaList(DynamicArray <String> *StrArray);   //      ,  - .
AnsiString Norm_StrCommaList(AnsiString& Str);  //""  -    ...
bool Check_StrCommaList(AnsiString& Str);  //   ...
void StrCommaList2StrArray(AnsiString InputStr, DynamicArray <String> *OutputArray);  //     ...

//AnsiString ProgPath;

#endif
